/*-----------------------------------*\
  @TOOLS #MIXINS
\*-----------------------------------*/

@mixin clearfix() {
	*zoom: 1;
	&:before, &:after { content: ""; display: table; }
	&:after { clear: both; }
}

// Transition effects
@mixin trans {
  transition: all .2s cubic-bezier(0.25, 0.1, 0.25, 1);
}

// Alignment
@mixin center {
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
}

@mixin center-h {
  position: absolute;
  left: 50%;
  transform: translateX(-50%);
}

@mixin center-v {
  position: absolute;
  top: 50%;
  transform: translateY(-50%);
}

/**
 * Create properties for spacing
 * @param  {string}  Class name abbreviation
 * @param  {string}  CSS value
 * @return {string}
 */
@mixin create-spacer-property ($prop, $value) {
  @if $prop == 'p' {
    padding: $value;
  } @else if $prop == 'pt' {
    padding-top: $value;
  } @else if $prop == 'pb' {
    padding-bottom: $value;
  } @else if $prop == 'py' {
    padding-top: $value;
    padding-bottom: $value;
  } @else if $prop == 'px' {
    padding-left: $value;
    padding-right: $value;
  } @else if $prop == 'm' {
    margin: $value;
  } @else if $prop == 'mt' {
    margin-top: $value;
  } @else if $prop == 'mb' {
    margin-bottom: $value;
  } @else if $prop == 'my' {
    margin-top: $value;
    margin-bottom: $value;
  } @else if $prop == 'mx' {
    margin-left: $value;
    margin-right: $value;
  }
}

/**
 * Generate spacer classes
 * @param  {string}   Spacer abbreviation (p, pb, pt, py...)
 * @param  {string}   CSS property (padding, padding-bottom...)
 * @param  {CSS unit} Unit used for spacing
 * @return {string}   CSS class
 */
@mixin create-spacer ($abbrev, $factor: $multiplier) {
  @each $breakpoint, $scales in map-get($spacing, $abbrev) {
    @if $breakpoint == null {
      @each $scale in $scales {
        @if $scale != null {
          .#{$abbrev}-#{$scale}x {
            @include create-spacer-property($abbrev, $scale * $factor);
          }
        }
      }
    } @else {
      @media (min-width: #{map-get($breakpoints, $breakpoint)}) {
        @each $scale in $scales {
          @if $scale != null {
            .#{$abbrev}-#{$scale}x {
              @include create-spacer-property($abbrev, $scale * $factor);
            }
          }
        }
      }
    }
  }
}

@mixin create-text-align {
  @each $text-alignment, $breaks in $text-alignments {
    @each $break in $breaks {
      @if $break == null {
        .text-#{$text-alignment} {
          text-align: $text-alignment;
        }
      } @else {
       @media (min-width: map-get($breakpoints, $break)) {
         .text-#{$text-alignment}-#{$break} {
            text-align: $text-alignment;
          }
        }
      }
    }
  }
}

@mixin create-columns {
  @each $breakpoint, $columns in $breakpoint-column {
    @if $breakpoint == null {
      @each $column in $columns {
        .col-#{$column} {
          width: percentage($column/$cols);
        }
      }
    } @else {
      @media (min-width: map-get($breakpoints, $breakpoint)) {
        @each $column in $columns {
          .col-#{$breakpoint}-#{$column} {
            width: percentage($column/$cols);
          }
        }
      }
    }
  }
}

@mixin create-column-offsets {
  @each $breakpoint, $columns in $breakpoint-offset {
    @if $breakpoint == null {
      @each $column in $columns {
        .offset-#{$column} {
          margin-left: percentage($column/$cols);
        }
      }
    } @else {
      @media (min-width: map-get($breakpoints, $breakpoint)) {
        @each $column in $columns {
          .offset-#{$breakpoint}-#{$column} {
            margin-left: percentage($column/$cols);
          }
        }
      }
    }
  }
}
